"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ArrayTools = /** @class */ (function () {
    function ArrayTools() {
    }
    ArrayTools.filter = function (array, criteria) {
        var filtered = [];
        for (var i = 0; i < array.length; i++) {
            if (criteria(array[i])) {
                filtered.push(array[i]);
            }
        }
        return filtered;
    };
    ArrayTools.filterGeneric = function (array, criteria) {
        var filtered = [];
        for (var i = 0; i < array.length; i++) {
            if (criteria(array[i])) {
                filtered.push(array[i]);
            }
        }
        return filtered;
    };
    ArrayTools.delete = function (item, array) {
        var index = array.indexOf(item);
        if (index >= 0) {
            array.splice(index, 1);
        }
    };
    ArrayTools.add = function (item, array) {
        array.push(item);
    };
    ArrayTools.clear = function (array) {
        array.splice(0, array.length);
    };
    ArrayTools.insertAfter = function (index, item, array) {
        if ((index >= 0) && (index < array.length)) {
            array.splice(index, 0, item);
        }
    };
    ArrayTools.insertBefore = function (index, item, array) {
        if ((index >= 1) && (index < array.length)) {
            array.splice(index - 1, 0, item);
        }
    };
    ArrayTools.anyOfFirstIsInSecond = function (firstArray, secondArray) {
        for (var i = 0; i < firstArray.length; i++) {
            if (secondArray.indexOf(firstArray[i]) > -1) {
                return true;
            }
        }
        return false;
    };
    ArrayTools.allOfFirstIsInSecond = function (firstArray, secondArray) {
        for (var i = 0; i < firstArray.length; i++) {
            if (secondArray.indexOf(firstArray[i]) === -1) {
                return false;
            }
        }
        return true;
    };
    ArrayTools.canMoveUp = function (item, array) {
        return (array.indexOf(item) > 0);
    };
    ArrayTools.canMoveDown = function (item, array) {
        return (array.indexOf(item) < array.length - 1);
    };
    ArrayTools.moveUp = function (item, array) {
        if (this.canMoveUp(item, array)) {
            var index = array.indexOf(item);
            this.delete(item, array);
            this.insertAfter(index - 1, item, array);
        }
    };
    ArrayTools.moveDown = function (item, array) {
        if (this.canMoveDown(item, array)) {
            var index = array.indexOf(item);
            this.delete(item, array);
            if (index === array.length - 1) {
                array.push(item);
            }
            else {
                this.insertAfter(index + 1, item, array);
            }
        }
    };
    return ArrayTools;
}());
exports.ArrayTools = ArrayTools;
