"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var keyvaluepair_1 = require("../models/keyvaluepair");
var arraytools_1 = require("./arraytools");
var KeyValuePairArray = /** @class */ (function (_super) {
    __extends(KeyValuePairArray, _super);
    function KeyValuePairArray(items) {
        return _super.apply(this, items) || this;
    }
    KeyValuePairArray.create = function () {
        return Object.create(KeyValuePairArray.prototype);
    };
    KeyValuePairArray.prototype.findByKey = function (key) {
        var matches = arraytools_1.ArrayTools.filterGeneric(this, function (item) { return item.key === key; });
        if (matches.length === 0) {
            return null;
        }
        return matches[0].value;
    };
    KeyValuePairArray.prototype.add = function (key, value) {
        var match = this.findByKey(key);
        if (match == null) {
            this.push(new keyvaluepair_1.KeyValuePair(key, value));
        }
    };
    KeyValuePairArray.prototype.addKeyValuePair = function (keyValuePair) {
        var match = this.findByKey(keyValuePair.key);
        if (match == null) {
            this.push(keyValuePair);
        }
    };
    KeyValuePairArray.prototype.remove = function (key) {
        var match = this.findByKey(key);
        if (match != null) {
            arraytools_1.ArrayTools.delete(match, this);
        }
    };
    return KeyValuePairArray;
}(Array));
exports.KeyValuePairArray = KeyValuePairArray;
